 PROGRAM


!-------------------------------------------------------------
!
! Program:  CWBBTEST
!
!   Sample program to demonstrate the use of the CWBB.VBX Toolbar button
!   in a CW Application.
!
!   CWBB.VBX has one property 'ButtonNo' which specifies the button's image
!   and text.  The image is loaded from the .VBX's attached resources.
!   Images are identified by resource ID number with the first image having
!   an ID of 5000.  The 2nd Button is 5001, etc.
!   The Text Displayed is loaded from the File's String Table Resource with
!   Button 0 having a Resource ID of 5500.  The 2nd button text being 5501, etc.
!   The .VBX Resources may be edited with a Windows Resource Editor such
!   as Microsoft's AppStudio. Edit the .VBX as if it were a .RC.
!
!   When a button is Clicked it produces a Clarion EVENT:VBXEvent.  This
!   Event is trapped in the Accept Loop.  The Field() which generated the
!   EVENT:VBXEvent will contain the VBXEvent in it's VBXEvent Property
!   {Prop:VBXEvent}
!

    INCLUDE('EQUATES')
    INCLUDE('KEYCODES')
    INCLUDE('ERRORS')
    MAP
       ABOUT()
    .

Main   APPLICATION('VBX Bitmap Text Button Sample'),AT(-5,-11,315,172),CENTER,SYSTEM,MAX,RESIZE,STATUS
         MENUBAR
           MENU('&File')
             ITEM('&About'),USE(?File_About)
             ITEM('&Exit'),USE(?File_Exit)
           END
         END
         TOOLBAR,AT(0,0,315,29)
           CUSTOM('Custom 1'),AT(2,1,23,20),USE(?Button1),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('0')
           CUSTOM('Custom 2'),AT(26,1,23,20),USE(?Button2),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('1')
           CUSTOM('Custom 3'),AT(50,1,23,20),USE(?Button3),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('2')
           CUSTOM('Custom 4'),AT(74,1,23,20),USE(?Button4),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('3')
           CUSTOM('Custom 5'),AT(98,1,23,20),USE(?Button5),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('4')
           CUSTOM('Custom 6'),AT(122,1,23,20),USE(?Button6),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('5')
           CUSTOM('Custom 7'),AT(146,1,23,20),USE(?Button7),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('6')
           CUSTOM('Custom 8'),AT(170,1,23,20),USE(?Button8),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('7')
           CUSTOM('Custom 9'),AT(194,1,23,20),USE(?Button9),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('8')
           CUSTOM('Custom 10'),AT(218,1,23,20),USE(?Button10),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('9')
           CUSTOM('Custom 11'),AT(242,1,23,20),USE(?Button11),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('10')
           CUSTOM('Custom 12'),AT(266,1,23,20),USE(?Button12),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('11')
           CUSTOM('Custom 13'),AT(290,1,23,20),USE(?Button13),CLASS('CWBB.VBX','CWBB'),'ButtonNo'('12')
         END
       END


    CODE
    OPEN(Main)
    ?Button1{'ButtonNo'} = 0           ! Set the Button Image based on the
    ?Button2{'ButtonNo'} = 1           ! Resource File Bitmaps
    ?Button3{'ButtonNo'} = 2
    ?Button4{'ButtonNo'} = 3
    ?Button5{'ButtonNo'} = 4
    ?Button6{'ButtonNo'} = 5
    ?Button7{'ButtonNo'} = 6
    ?Button8{'ButtonNo'} = 7
    ?Button9{'ButtonNo'} = 8
    ?Button10{'ButtonNo'} = 9
    ?Button11{'ButtonNo'} = 10
    ?Button12{'ButtonNo'} = 11
    ?Button13{'ButtonNo'} = 12

    ACCEPT
      CASE EVENT()
      OF Event:Accepted
        CASE ACCEPTED()
        OF ?File_Exit
          Break                        ! Break on File/Exit
        OF ?File_About
          About
        .

      OF EVENT:VBXEvent                ! A VBX Event has occurred
        CASE FIELD(){PROP:VBXEvent}    ! Check which Event it was
        OF 'Click'                     ! A Click was detected
          Junk# = Message('Button ' & FIELD(){'ButtonNo'} & ' Pressed')
        .
      .
    .

About   Procedure

AboutWindow WINDOW('CDBB Example'),AT(,,169,48),CENTER,SYSTEM,GRAY,DOUBLE
         BUTTON('&Ok'),AT(122,20,,),USE(?AboutOK)
         STRING('Demonstration of CWBB.VBX'),AT(20,6,,),USE(?String1)
         STRING('DataTXT Corporation, USA'),AT(20,15,,),USE(?String2)
         STRING('Tested with CW Build 530'),AT(20,24,,),USE(?String3)
         STRING('Last Revised 27 JUL 94'),AT(20,33,,),USE(?String4)
       END

    CODE
    OPEN(AboutWindow)
    ACCEPT
      IF ACCEPTED() = ?AboutOK then break .
    .
