' RWARRAYS.BAS
' Example program to demonstrate reading and writing arrays
' to disk files using the RWARRAYS.DLL.
' (c) Marcus Schommler, 1994
'     CServe 100335,3620

Option Explicit

' Functions to read and write arrays from the DLL
Declare Function arr_write Lib "rwarrays.dll" (Arr() As Any, s As String) As Integer
Declare Function arr_read Lib "rwarrays.dll" (Arr() As Any, s As String) As Integer

' User defined type for demonstrating reading and writing
' of arrays of UDTs
Type TExample
    s As String * 10
    i As Integer
    l As Long
    d As Double
End Type

Sub main ()
    ReDim Arr1(100, 100) As Single
    ReDim Arr2(40, 40) As TExample
    Dim i%, j%, k%, f%

    ChDir App.Path
    
    Screen.MousePointer = 11
    ' First example : reading and writing an array of
    ' type "single"

    ' fill the array with data :
    For i = 1 To 100
        For j = 1 To 100
            Arr1(i, j) = (i - 1) * 100 + j
        Next
    Next
    
    i = arr_write(Arr1(), "test1.dat") ' write out

    Erase Arr1 ' delete contents of Arr1
    ReDim Arr1(100, 100) As Single
    
    ' Beeping before and after reading from the file
    ' to check how long an array load of 10000 elements takes.
    Beep
    i = arr_read(Arr1(), "test1.dat") ' read in the file
    Beep

    ' print contents of array to text file :
    f = FreeFile
    Open "test1.txt" For Output As f
    For i = 1 To 100
        For j = 1 To 100
            Print #f, Format$(Arr1(i, j), "#####"); " ";
        Next
        Print #f, ""
    Next
    Close f

    ' Second example : Reading and writing arrays containing
    ' user defined types

    ' fill the array with data :
    For i = 1 To 40
        For j = 1 To 40
            k = (i - 1) * 40 + j
            Arr2(i, j).s = "S: " & CStr(k)
            Arr2(i, j).i = k
            Arr2(i, j).l = k * 100000
            Arr2(i, j).d = k * 1E-44
        Next
    Next

    i = arr_write(Arr2(), "test2.dat")

    Erase Arr2 ' delete contents of Arr2
    ReDim Arr2(40, 40) As TExample

    i = arr_read(Arr2(), "test2.dat") ' read in the file
    
    ' print contents of array to text file :
    f = FreeFile
    Open "test2.txt" For Output As f
    For i = 1 To 40
        For j = 1 To 40
            Print #f, Arr2(i, j).s, Arr2(i, j).i, Arr2(i, j).l, Arr2(i, j).d
        Next
    Next
    Close f

    Screen.MousePointer = 1
    End
End Sub

